unit Unit16;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Htmldb16, DB, DBTables, StdCtrls;

type
  TForm16 = class(TForm)
    Query: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    HtmlDBGrid1: THtmlDBGrid;
    Query1: TQuery;
    Edit3: TEdit;
    Label3: TLabel;
    procedure HtmlDBGrid1CustomiseField(Sender: TObject; Field: TField;
      var FieldString, Link, Image: OpenString;
      var FieldWidthType: TFieldWidthType; var TextColor, BGColor: TColor;
      var FontSize: TFontSize; var Bold, Italic, NoFlow, NoWrap: Boolean);
    procedure HtmlDBGrid1DrawText(Text: String);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form16: TForm16;

implementation

{$R *.DFM}
var
  F : TFileStream;

procedure TForm16.HtmlDBGrid1CustomiseField(Sender: TObject; Field: TField;
  var FieldString, Link, Image: OpenString;
  var FieldWidthType: TFieldWidthType; var TextColor, BGColor: TColor;
  var FontSize: TFontSize; var Bold, Italic, NoFlow, NoWrap: Boolean);
begin
  if AnsiUpperCase(Field.FieldName)='NAME' then
  begin
    TextColor:=Random($FFFF);
    FontSize:=fsSize4;
    Bold:=True
  end
  else if AnsiUpperCase(Field.FieldName)='CAPITAL' then
  begin
    TextColor:=Random($FFFF);
    Italic:=True;
  end
  else if AnsiUpperCase(Field.FieldName)='CONTINENT' then
  begin
    Link:='MyInvalidPage.htm?'+FieldString;
  end
  else if AnsiUpperCase(Field.FieldName)='POPULATION' then
  begin
    Link:='MyInvalidPage2.htm?'+FieldString;
  end
end;

procedure TForm16.HtmlDBGrid1DrawText(Text: String);
begin
  f.write(Text[1],Length(Text));
end;

procedure TForm16.Button1Click(Sender: TObject);
begin
   f:=TFileStream.Create(Edit2.Text,fmCreate);
  HtmlDBGrid1DrawText('<HTML><HEAD><TITLE>HtmlDBGrid test</TITLE><BODY>'+#13#10);
  Query1.Databasename:=Edit3.Text;
  Query1.SQL.Clear;
  Query1.SQL.Add(Edit1.Text);
  Query1.Open;
  HtmlDBGrid1.DrawGrid(modeNetscape);
  HtmlDBGrid1DrawText('</BODY></HTML>'+#13#10);
  F.Free;
  Query1.Close;
  MessageDlg('File has been generated', mtInformation,[mbOk], 0);
end;

end.
